<?php
/**
 * Plugin Name: Northmill Checkout
 * Plugin URI: https://northmill.com/se/foretag/betallosningar/checkout/
 * Description: Payment gateways for WooCommerce. Credit card payment via Northmill. Support for invoice, Swish and partial payment via Resurs Bank.
 * Author: Northmill
 * Author URI: https://northmill.com/se/foretag/
 * Version: 2.0.13
 * WC tested up to:  8.5.2
 * License: GNU General Public License v3.0
 * License URI: http://www.gnu.org/licenses/gpl-3.0.html
 * Requires PHP: 8.2
 *
 * @package flo-checkout
 */

use Flo_Checkout\Setup;

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}
define( 'FLO_CHECKOUT_URL', plugin_dir_url( __FILE__ ) );
define( 'FLO_CHECKOUT_PATH', plugin_dir_path( __FILE__ ) );
define( 'FLO_CHECKOUT_REL_PATH', dirname( plugin_basename( __FILE__ ) ) );
define( 'FLO_CHECKOUT_PLUGIN_FILENAME', basename( plugin_basename( __FILE__ ) ) );

require_once FLO_CHECKOUT_PATH . '/vendor/autoload.php';

define( 'FLO_CHECKOUT', 'flo-checkout' );
define( 'WC_FAILED_STATUS', 'wc-failed' );
define( 'WC_COMPLETED_STATUS', 'wc-completed' );
define( 'WC_PENDING_STATUS', 'wc-pending' );
define( 'WC_CANCELLED_STATUS', 'wc-cancelled' );

$file_data = get_file_data( __FILE__, array( 'Version' => 'Version' ) );
define( 'FLO_CHECKOUT_VERSION', $file_data['Version'] );

// Set up all plugin gateways.
add_action( 'plugins_loaded', array( Setup::class, 'setup' ) );

add_action(
	'before_woocommerce_init',
	function () {
		if ( class_exists( \Automattic\WooCommerce\Utilities\FeaturesUtil::class ) ) {
			\Automattic\WooCommerce\Utilities\FeaturesUtil::declare_compatibility( 'custom_order_tables', __FILE__, false );
		}
	}
);
