<?php
/**
 * Renders the certificate form modal.
 */

defined( 'ABSPATH' ) || exit;

/**
 * Blog URL
 *
 * @var string $domain
 */

/**
 * Admin email
 *
 * @var string $email_address
 */
?>

<div id="nm-generate-cert-modal-container">
	<div id="nm-generate-cert-modal">
		<h3><?php esc_html_e( 'Information for certificate', 'flo-checkout-plugin' ); ?></h3>
		<p>
			<label
				for="nm-generate-new-cert-country"><?php esc_html_e( 'Country', 'flo-checkout-plugin' ); ?></label><br>
			<input type="text" id="nm-generate-new-cert-country" value="SE" readonly>
		</p>
		<p>
			<label for="nm-generate-new-cert-city"><?php esc_html_e( 'City', 'flo-checkout-plugin' ); ?></label><br>
			<input type="text" id="nm-generate-new-cert-city">
		</p>
		<p>
			<label
				for="nm-generate-new-cert-organization"><?php esc_html_e( 'Organization name', 'flo-checkout-plugin' ); ?></label><br>
			<input type="text" id="nm-generate-new-cert-organization">
		</p>
		<p>
			<label
				for="nm-generate-new-cert-common-name"><?php esc_html_e( 'Common name (domain)', 'flo-checkout-plugin' ); ?></label><br>
			<input type="text" id="nm-generate-new-cert-common-name" value="<?php echo esc_attr( $domain ); ?>">
		</p>
		<p>
			<label
				for="nm-generate-new-cert-email"><?php esc_html_e( 'Email', 'flo-checkout-plugin' ); ?></label><br>
			<input type="text" id="nm-generate-new-cert-email"
					value="<?php echo esc_attr( $email_address ); ?>">
		</p>
		<button id="nm-generate-new-cert"><?php esc_html_e( 'Generate', 'flo-checkout-plugin' ); ?></button>
		<button
			id="nm-generate-new-cert-cancel"><?php esc_html_e( 'Cancel', 'flo-checkout-plugin' ); ?></button>
	</div>
</div>
